Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.lucene.index
Class ParallelAtomicReader

    java.lang.Object
      org.apache.lucene.index.IndexReader
          org.apache.lucene.index.AtomicReader
              org.apache.lucene.index.ParallelAtomicReader

All Implemented Interfaces:
  Closeable

    public class ParallelAtomicReader

extends AtomicReader

An `AtomicReader` which reads multiple, parallel indexes. Each index added must have the same number of documents, but typically each contains different fields. Deletions are taken from the first reader. Each document contains the union of the fields of all documents with the same document number. When searching, matches for a query term are from the first index added that has the field.

This is useful, e.g., with collections that have large fields which change rarely and small fields that change more frequently. The smaller fields may be re-indexed in a new index and both indexes may be searched together.

Warning: It is up to you to make sure all indexes are created and modified the same way. For example, if you add documents to one index, you need to add the same documents in the same order to the other indexes. Failure to do so will result in undefined behavior.

Nested Class Summary

Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader
`IndexReader.ReaderClosedListener`

Constructor Summary
`ParallelAtomicReader(AtomicReader... readers)` Create a ParallelAtomicReader based on the provided readers; auto-closes the given readers on `IndexReader.close()`.
`ParallelAtomicReader(boolean closeSubReaders, AtomicReader... readers)` Create a ParallelAtomicReader based on the provided readers.
`ParallelAtomicReader(boolean closeSubReaders, AtomicReader[] readers, AtomicReader[] storedFieldsReaders)` Expert: create a ParallelAtomicReader based on the provided readers and storedFieldReaders; when a document is loaded, only storedFieldsReaders will be used.

Method Summary
`protected void` | `doClose()` Implements close.
`void` | `document(int docID, StoredFieldVisitor visitor)` Expert: visits the fields of a stored document, for custom processing/loading of each field.
`Fields` | `fields()` Returns `Fields` for this reader.
`BinaryDocValues` | `getBinaryDocValues(String field)` Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field.
`FieldInfos` | `getFieldInfos()` Get the `FieldInfos` describing all fields in this reader.
`Bits` | `getLiveDocs()` Returns the `Bits` representing live (not deleted) docs.
`NumericDocValues` | `getNormValues(String field)` Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed.
`NumericDocValues` | `getNumericDocValues(String field)` Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field.
`SortedDocValues` | `getSortedDocValues(String field)` Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field.
`SortedSetDocValues` | `getSortedSetDocValues(String field)` Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field.
`Fields` | `getTermVectors(int docID)` Retrieve term vectors for this document, or null if term vectors were not indexed.
`int` | `maxDoc()` Returns one greater than the largest possible document number.
`int` | `numDocs()` Returns the number of documents in this index.
`String` | `toString()`

Methods inherited from class org.apache.lucene.index.AtomicReader
`docFreq, getContext, getDocCount, getSumDocFreq, getSumTotalTermFreq, hasNorms, termDocsEnum, termPositionsEnum, terms, totalTermFreq`

Methods inherited from class org.apache.lucene.index.IndexReader
`addReaderClosedListener, close, decRef, document, document, ensureOpen, equals, getCombinedCoreAndDeletesKey, getCoreCacheKey, getRefCount, getTermVector, hasDeletions, hashCode, incRef, leaves, numDeletedDocs, open, open, open, open, open, registerParentReader, removeReaderClosedListener, tryIncRef`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### ParallelAtomicReader

    public ParallelAtomicReader(AtomicReader... readers)
                         throws IOException

  Create a ParallelAtomicReader based on the provided readers; auto-closes the given readers on `IndexReader.close()`.

  Throws:
    `IOException`

### ParallelAtomicReader

    public ParallelAtomicReader(boolean closeSubReaders,
                                AtomicReader... readers)
                         throws IOException

  Create a ParallelAtomicReader based on the provided readers.

  Throws:
    `IOException`

### ParallelAtomicReader

    public ParallelAtomicReader(boolean closeSubReaders,
                                AtomicReader[] readers,
                                AtomicReader[] storedFieldsReaders)
                         throws IOException

  Expert: create a ParallelAtomicReader based on the provided readers and storedFieldReaders; when a document is loaded, only storedFieldsReaders will be used.

  Throws:
    `IOException`

Method Detail

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### getFieldInfos

    public FieldInfos getFieldInfos()

  Get the `FieldInfos` describing all fields in this reader.

  NOTE: the returned field numbers will likely not correspond to the actual field numbers in the underlying readers, and codec metadata (`FieldInfo.getAttribute(String)` will be unavailable.

  Specified by:
    `getFieldInfos` in class `AtomicReader`

### getLiveDocs

    public Bits getLiveDocs()

  Description copied from class: `AtomicReader`
  Returns the `Bits` representing live (not deleted) docs. A set bit indicates the doc ID has not been deleted. If this method returns null it means there are no deleted documents (all documents are live). The returned instance has been safely published for use by multiple threads without additional synchronization.

  Specified by:
    `getLiveDocs` in class `AtomicReader`

### fields

    public Fields fields()

  Description copied from class: `AtomicReader`
  Returns `Fields` for this reader. This method may return null if the reader has no postings.

  Specified by:
    `fields` in class `AtomicReader`

### numDocs

    public int numDocs()

  Description copied from class: `IndexReader`
  Returns the number of documents in this index.

  Specified by:
    `numDocs` in class `IndexReader`

### maxDoc

    public int maxDoc()

  Description copied from class: `IndexReader`
  Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.

  Specified by:
    `maxDoc` in class `IndexReader`

### document

    public void document(int docID,
                         StoredFieldVisitor visitor)
                  throws IOException

  Description copied from class: `IndexReader`
  Expert: visits the fields of a stored document, for custom processing/loading of each field. If you simply want to load all fields, use `IndexReader.document(int)`. If you want to load a subset, use `DocumentStoredFieldVisitor`.

  Specified by:
    `document` in class `IndexReader`
  Throws:
    `IOException`

### getTermVectors

    public Fields getTermVectors(int docID)
                          throws IOException

  Description copied from class: `IndexReader`
  Retrieve term vectors for this document, or null if term vectors were not indexed. The returned Fields instance acts like a single-document inverted index (the docID will be 0).

  Specified by:
    `getTermVectors` in class `IndexReader`
  Throws:
    `IOException`

### doClose

    protected void doClose()
                    throws IOException

  Description copied from class: `IndexReader`
  Implements close.

  Specified by:
    `doClose` in class `IndexReader`
  Throws:
    `IOException`

### getNumericDocValues

    public NumericDocValues getNumericDocValues(String field)
                                         throws IOException

  Description copied from class: `AtomicReader`
  Returns `NumericDocValues` for this field, or null if no `NumericDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Specified by:
    `getNumericDocValues` in class `AtomicReader`
  Throws:
    `IOException`

### getBinaryDocValues

    public BinaryDocValues getBinaryDocValues(String field)
                                       throws IOException

  Description copied from class: `AtomicReader`
  Returns `BinaryDocValues` for this field, or null if no `BinaryDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Specified by:
    `getBinaryDocValues` in class `AtomicReader`
  Throws:
    `IOException`

### getSortedDocValues

    public SortedDocValues getSortedDocValues(String field)
                                       throws IOException

  Description copied from class: `AtomicReader`
  Returns `SortedDocValues` for this field, or null if no `SortedDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Specified by:
    `getSortedDocValues` in class `AtomicReader`
  Throws:
    `IOException`

### getSortedSetDocValues

    public SortedSetDocValues getSortedSetDocValues(String field)
                                             throws IOException

  Description copied from class: `AtomicReader`
  Returns `SortedSetDocValues` for this field, or null if no `SortedSetDocValues` were indexed for this field. The returned instance should only be used by a single thread.

  Specified by:
    `getSortedSetDocValues` in class `AtomicReader`
  Throws:
    `IOException`

### getNormValues

    public NumericDocValues getNormValues(String field)
                                   throws IOException

  Description copied from class: `AtomicReader`
  Returns `NumericDocValues` representing norms for this field, or null if no `NumericDocValues` were indexed. The returned instance should only be used by a single thread.

  Specified by:
    `getNormValues` in class `AtomicReader`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.